#!/usr/bin/perl

use FindBin;
use Locale::Maketext::Extract;
my $lexicon = Locale::Maketext::Extract->new;

my $whitespace = qr/[^\S ]+/;
my $tag = qr/<[^>]+>/;
my $control = qr/\[%(?:#|\s+[A-Z]).*?%\]/s;
my $var = qr/\[% .*? %\]/s;
my $text = '';

foreach my $file (<$FindBin::Bin/../../templates/*default>) {
    open FH, $file or die $!;
    my $chunk = join '', <FH>;
    $chunk =~ /__template__(.*)__seclev__/s or die;
    $chunk = $1;
    $chunk =~ s/\[%\|l.*?\%END%\]//g;
    $text = '';
    extract($chunk);
}

$lexicon->write_po('messages.po');


sub extract {
    my $string = $_[0];
    my $cont;
    while ($string =~ s/^(.*?)(\n\n+|\s+\|\s+|\s+\/\s+|($tag)|($control)|($var)|=|[(\[]\s+|\s+[\])])//s) {
	if ($1) {
	    if ($cont--) {
		$text .= $1;
	    }
	    else {
		do_text();
		$text = $1;
	    }
	}
	if ($5) {
	    $text .= $5;
	    $cont = 1;
	}
	elsif ($3) {
	    my $t = $3;
	    if (length $text and $t =~ m!<(/?)(a|strong|em|i|b)\b!) {
		if ($1) {
		    next unless $text =~ m!<$2!; 
		}
		$text .= $t;
		$cont = 1;
	    }
	    else {
		$cont = 0;
		extract($_) foreach $t =~ /\b(?:alt|title|value)="([^"]+)"/g;
	    }
	}
	else {
	    do_text();
	    $cont = 0;
	}
    }
    do_text();
    $text = $string;
    do_text();
}


sub do_text {
    return if $text =~ /^\s*$/;
    return if $text =~ /^\s*\[%(.*)%\]\s*$/s and $1 !~ /%].+\[%/s;
    return if $text =~ /^\W*<[^>]+>$/;
    my $cnt = 1;
    my %cnt;
    $text =~ s/\[%(.*?)%\]/'COUNTXXX'.($cnt{$1}||=$cnt++)/egs;
    $text =~ s/^\s+//;
    $text =~ s/\s+$//;
    $text =~ s/^\W\s+//;
    return unless $text =~ /[\w^]/;
    return if $text =~ /^\[% FILTER/;
    $text =~ s/\n[ \t]*/\n/g;
    return if $text =~ /^\d+$/;
    $text =~ s{^<(\w+)[^>]*>(.+)</\1>$}{$1};
    return if $text =~ /\[%/;
    1 while $text =~ s{<(\w+)\s*([^>]*)\s*>(.*?)</\1>}{frob($1,$2,$3)}e;
    $cnt = 1;
    %cnt = ();
    $text =~ s/COUNTXXX(\d+)/'%'.($cnt{$1}||=$cnt++)/egs;
    $text =~ s/COMMAXXX/,/g;
    $text =~ s/\%A\(href,/\%A(/g;
    return if $text =~ /^(?:%\d+|\s+|<[^>]+>)*$/;
    $lexicon->set_msgstr($text, '');
    $text = '';
}

my $cnt = 1000;
sub frob {
    my ($tag, $attr, $content) = @_;
    $tag = uc($tag);
    $tag = 'B' if $tag eq 'STRONG';
    $tag = 'I' if $tag eq 'EM';
    my $mid = '';
    while ($attr =~ s/(\w+)=(['"])(.+?)\2//) {
	$cnt++;
	$mid .= "$1COMMAXXXCOUNTXXX${cnt}COMMAXXX";
    }
    $content =~ s/\\/\\\\/g;
    $content =~ s/([,%)])/\\$1/g;
    return "\%$tag($mid$content)";
}

